

$LIBRARY "sqlite3.lib"
#Include "include/sqlite3.h"

CONST   ID_Ver      =  200   'Main Menu member
CONST   ID_Options  =  300   'Main Menu member
CONST   ID_Open     =  400   'File Menu member
CONST   ID_Close    =  500   'File Menu member
CONST   ID_Save     =  600   'File Menu member
CONST   ID_SaveAs   =  700   'File Menu member
CONST   ID_Exit     =  800   'File Menu member

GLOBAL  Form1      AS  HWND
GLOBAL  MainMenu   AS  HMENU
GLOBAL  FileMenu   AS  HMENU
GLOBAL  CustomKeys AS  HACCEL
GLOBAL  astring$
GLOBAL  db         AS sqlite3 PTR
GLOBAL  CURRENTPOS
GLOBAL  rc         AS LONG


GUI "BCX_Template", PIXELS

SUB FORMLOAD
DIM RAW iret%

   SET sAccel[] AS ACCEL
      FCONTROL OR FVIRTKEY, ASC("O"), ID_Open,
      FCONTROL OR FVIRTKEY, ASC("S"), ID_Save
   END SET

  Form1 = BCX_FORM("Form1", 0, 0, 310, 310)
  
  '========================================================================
   '                          Start Building Menus
   '========================================================================
   MainMenu   =  CreateMenu()   ' CreateMenu returns a MENU HANDLE
   FileMenu   =  CreateMenu()   ' CreateMenu returns a MENU HANDLE
   '========================================================================
   '                     Build the File Menu First
   '========================================================================
   AppendMenu(FileMenu,MF_STRING   ,ID_Open  ,"&Write DB" + CHR$(9) + "Ctrl+O")
   AppendMenu(FileMenu,MF_STRING   ,ID_Close ,"&Close")
   AppendMenu(FileMenu,MF_STRING   ,ID_Save  ,"&Read DB" + CHR$(9) + "Ctrl+S")
   AppendMenu(FileMenu,MF_STRING   ,ID_SaveAs,"Save &As")
   AppendMenu(FileMenu,MF_SEPARATOR,    0    ,"")
   AppendMenu(FileMenu,MF_STRING   ,ID_Exit  ,"E&xit")
   '========================================================================
   '                        Build the Main Menu Next
   '========================================================================
   AppendMenu ( MainMenu , MF_STRING , ID_Ver    , "SQLite Version")
   AppendMenu ( MainMenu , MF_STRING , ID_Options , "Options")
   '========================================================================
   '                  Attach the File menu to the main menu
   '========================================================================
   InsertMenu ( MainMenu, ID_Ver , MF_POPUP , FileMenu ,"File")
   '========================================================================
   SetMenu(Form1,MainMenu)              ' Activate the menu

CENTER (Form1)
  SHOW (Form1)
END SUB

BEGIN EVENTS
SELECT CASE CBMSG
   '========================================================================
   CASE WM_COMMAND
   '========================================================================
   SELECT CASE CBCTL
         CASE ID_Exit : PostQuitMessage(0)
         CASE ID_Open : CALL CreateDB(1)
         CASE ID_Save : CALL CreateDB(0)
	 CASE ID_Ver  : CALL DBVersion()
	 CASE ID_Options : MSGBOX "Options"
   END SELECT
      
   CASE WM_CLOSE
     sqlite3_close(db)   ' close the database
     DestroyWindow (Form1)
     EXIT FUNCTION

END SELECT
END EVENTS

SUB DBVersion()
   astring$ = sqlite3_libversion()
   MSGBOX "SQLite version: " & astring$
END SUB 

SUB CreateDB(ReadWrite AS INTEGER)
DIM st$, iret%
STATIC nBlob
STATIC szFileName$

   iret% = sqlite3_open("code.db",&db)  
   IF iret% <> SQLITE_OK THEN 'SQLITE_OK = 0
     msgbox "Opening <code.db> failed!", JOIN$(2, APPEXENAME$, "will terminate now."), MB_OK|MB_ICONERROR
   END IF   
   
   astring$ = "CREATE TABLE blobs(key TEXT PRIMARY KEY, value BLOB)"
   rc = sqlite3_exec(db,astring$,NULL,NULL,NULL)

   szFileName$=GETFILENAME$ ("Open basic file.","*.bas")
   nBlob = LOF(szFileName$) 
  
   STATIC zBlob$ * LOF(szFileName$) 

IF ReadWrite THEN 
   OPEN szFileName$ FOR BINARY AS Fp1 
   GET$ Fp1, zBlob$, LOF(szFileName$)
   CLOSE Fp1
  
   IF SQLITE_OK <> WriteBlob(db, szFileName$, zBlob$, nBlob) THEN 
    MSGBOX "WriteBlob failed!"
   END IF
ELSE

   IF SQLITE_OK <> ReadBlob(db, szFileName$, &zBlob, &nBlob) THEN
     MSGBOX "ReadBlob failed!"
   END IF
   
   MSGBOX STR$(nBlob) + CRLF$ + "    " + STR$(LEN(zBlob$))

   OPEN "zzzzzzz.bas" FOR BINARY NEW AS Fp2 
   PUT$ Fp2, zBlob, nBlob
   CLOSE Fp2
    
   IF NOT LEN(zBlob$) THEN 
     MSGBOX "No such database entry: " + szFileName$
   END IF   

END IF
   FREE zBlob$

END SUB 


 ' Store a blob in database db. Return an SQLite error code.

 ' This function inserts a new row into the blobs table. The 'key' column
 ' of the new row is set to the string pointed to by parameter zKey. The
 ' blob pointed to by zBlob, size nBlob bytes, is stored in the 'value' 
 ' column of the new row.
FUNCTION WriteBlob(dat AS sqlite3 PTR, _   ' Database to insert data into 
                   zKey$,              _   ' Null-terminated key string 
		   zBlob$,             _   ' Pointer to blob of data 
		   nBlob AS INTEGER)   _   ' Length of data pointed to by zBlob 
		   AS INTEGER            

DIM zSql$
DIM pStmt AS sqlite3_stmt PTR
DIM rc AS INTEGER

  zSql$ = "INSERT INTO blobs(key, value) VALUES(?, ?)"

  DO 
    'Compile the INSERT statement into a virtual machine.
    rc = sqlite3_prepare(db, zSql, -1, &pStmt, 0)
    if  rc <> SQLITE_OK THEN FUNCTION = rc

    ' Bind the key and value data for the new table entry to SQL variables
    ' (the ? characters in the sql statement) in the compiled INSERT 
    ' statement. 
    
    ' NOTE: variables are numbered from left to right from 1 upwards.
    ' Passing 0 as the second parameter of an sqlite3_bind_XXX() function 
    ' is an error.
    
    sqlite3_bind_text(pStmt, 1, zKey$, -1, SQLITE_STATIC)
    sqlite3_bind_blob(pStmt, 2, zBlob$, nBlob, SQLITE_STATIC)
    
    ' Call sqlite3_step() to run the virtual machine. Since the SQL being
    ' executed is not a SELECT statement, we assume no data will be returned.
    
    rc = sqlite3_step(pStmt)
   ' assert( rc  <> SQLITE_ROW )

    ' Finalize the virtual machine. This releases all memory and other
    ' resources allocated by the sqlite3_prepare() call above.
    
    rc = sqlite3_finalize(pStmt)

    ' If sqlite3_finalize() returned SQLITE_SCHEMA, then try to execute
    ' the statement again.
    
   LOOP WHILE rc = SQLITE_SCHEMA 
   FUNCTION = rc
END FUNCTION
    


' Read a blob from database db. Return an SQLite error code.
FUNCTION ReadBlob(dat AS sqlite3 PTR,      _ ' Database containing blobs table
                   zKey$,       _ ' Null-terminated key to retrieve blob for
		   pzBlob AS CHAR PTR PTR, _ ' Set *pzBlob to point to the retrieved blob
		   pnBlob AS INTEGER PTR)  _ ' Set *pnBlob to the size of the retrieved blob
		   AS INTEGER 


DIM zSql$
DIM pStmt AS sqlite3_stmt PTR
DIM rc AS INTEGER

   zSql$ = "SELECT value FROM blobs WHERE key = ?"

   ' In case there is no table entry for key zKey or an error occurs, 
   ' set *pzBlob and *pnBlob to 0 now.
  
   *pzBlob = 0
   *pnBlob = 0

   DO
   'Compile the INSERT statement into a virtual machine.
   rc = sqlite3_prepare(db, zSql$, -1, &pStmt, 0)
   IF  rc <> SQLITE_OK THEN FUNCTION = rc
    
   'Bind the key to the SQL variable.
   sqlite3_bind_text(pStmt, 1, zKey$, -1, SQLITE_STATIC)
    
     ' Run the virtual machine. We can tell by the SQL statement that
     ' at most 1 row will be returned. So call sqlite3_step() once
     ' only. Normally, we would keep calling sqlite3_step until it
     ' returned something other than SQLITE_ROW.
    
    rc = sqlite3_step(pStmt)
    IF rc = SQLITE_ROW THEN
       ' The pointer returned by sqlite3_column_blob() points to memory
       ' that is owned by the statement handle (pStmt). It is only good
       ' until the next call to an sqlite3_XXX() function (e.g. the 
       ' sqlite3_finalize() below) that involves the statement handle. 
       ' So we need to make a copy of the blob into memory obtained from 
       ' malloc() to return to the caller.
      
       *pnBlob = sqlite3_column_bytes(pStmt, 0)
       *pzBlob = ( char *)malloc(*pnBlob)
       memcpy(*pzBlob, sqlite3_column_blob(pStmt, 0), *pnBlob)
    END IF     
    
    ' Finalize the statement (this releases resources allocated by 
    ' sqlite3_prepare() ).
    rc = sqlite3_finalize(pStmt)

    ' If sqlite3_finalize() returned SQLITE_SCHEMA, then try to execute
    ' the statement all over again.
    
    LOOP WHILE rc = SQLITE_SCHEMA
FUNCTION = rc
END FUNCTION

' Free a blob read by readBlob().
SUB FreeBlob (zBlob$)
  free(zBlob)
END SUB  

